

/*

    Variable Width Font demo for PC Engine
    --------------------------------------
    cabbage 2014-09-26
    http://pce.lifeabroad.org
    cabbage AT lifeabroad org               
    
*/


#include "huc.h"


const char sample[]={"Variable Width Font demo for PC Engine made by cabbage in 2014",0xFF};
const char _fntw[]={
    2,4,4,6,    4,4,5,2,    3,3,4,4,    3,4,2,3,    /* !*/
    4,4,4,4,    4,4,4,4,    4,4,2,3,    4,4,4,5,    /*01*/
    6,5,4,4,    5,4,4,5,    5,2,5,4,    4,6,5,5,    /*@A*/
    5,5,5,5,    5,5,6,6,    6,5,5,3,    4,3,4,4,    /*PQ*/
    3,5,5,4,    5,5,5,5,    5,2,4,4,    2,6,5,5,    /*`a*/
    5,5,5,4,    4,5,6,6,    5,5,4,4,    2,4,6,0     /*pq*/
};


#define _VWF_VRAM   0x0e00
int buffer[0x10]; /* one tile */
char bufcast; /*hacky*/
char _xoffs,_xrem; /*x offset, x remainder*/
char _chrval,_chrw; /*char value, char width*/
char _vwft; /*current tile (ie vram tile offset)*/
int c;/*string position*/


#incbin(_fntbin,"fnt.bin");


int scrollx;
int i;


main(){


    for(i=0;i<32;i++){
        put_raw(0xe0+i,i,13);
    }


    /* initialize */
    c=0;
    _xrem=0;
    _xoffs=0;
    _vwft=0;
    for(i=0;i<8;i++){
        buffer[i]=0;
    }


    /* advance frame-by-frame to see how slow this is ;-) */
    vsync();
    set_color_rgb(0,0,0,1);
    set_color_rgb(256,0,0,2);
    vsync();


    /*print the string*/
    while(1){
        /*grab char and its width*/
        _chrval=sample[c]-0x20;
        _chrw=_fntw[_chrval];

        /*check end-of-string*/
        if(_chrval>=0xDF){
            /* final export */
            load_vram(_VWF_VRAM+_vwft*0x10,buffer,0x10);
            break;
        }

        /*build buffer with current char*/
        for(i=0;i<8;i++){
            buffer[i]|=_fntbin[8*_chrval+i]>>_xoffs;
        }
        _xoffs+=_chrw;

        /* tile is full... */
        if(_xoffs>=8){
            /*export buffer to vram*/
            load_vram(_VWF_VRAM+_vwft*0x10,buffer,0x10);
            _vwft++;/*next tile in vram*/

            _xrem=_xoffs%8;
            /*clear buffer and build remainder of current char*/
            for(i=0;i<8;i++){
                /*hacky, cast char to int*/
                bufcast=_fntbin[8*_chrval+i]<<(_chrw-_xrem);
                buffer[i]=bufcast;
            }
            _xoffs=_xrem;
        }
        c++;/*next chr in string*/
    }


    /* compare to built in fixed width font */
    scrollx=0;
    scroll(0,0,0,0,111,0xc0);
    scroll(1,scrollx,112,112,223,0xc0);
    put_string(sample,0,14);
    while(1){
        vsync();
        scroll(1,scrollx,112,112,223,0xc0);
        scrollx++;
    }


}

